/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package imageopstest;

import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;



/**
 *
 * @author micha
 */
public class Dreieck extends Form {

    Punkt a, b, c;
    Color farbe;

    double getFlaeche() {
        Punkt ab = a.diff(b);
        Punkt ac = a.diff(c);
        double kreuz = ac.kreuz(ab);
        return Math.sqrt(kreuz*kreuz)/2;
    }

    void verschieben(Punkt vektor) {
        a=a.sum(vektor);
        b=b.sum(vektor);
        c=c.sum(vektor);
    }

    public void drehen(double winkel) {
        DrehMatrix dm = new DrehMatrix(winkel);
        a = dm.mult(a);
        b = dm.mult(b);
        c = dm.mult(c);
    }

    public Dreieck(Punkt a, Punkt b, Punkt c, Color color) {
        super(a);
        this.a = a;
        this.b = b;
        this.c = c;
        this.farbe = color;
    }

    public Dreieck(Punkt a, Punkt b, Punkt c){
        this(a,b,c, Color.BLACK);
    }
    
    public Punkt getA() {
        return a;
    }

    public void setA(Punkt a) {
        this.a = a;
    }

    public Punkt getB() {
        return b;
    }

    public void setB(Punkt b) {
        this.b = b;
    }

    public Punkt getC() {
        return c;
    }

    public void setC(Punkt c) {
        this.c = c;
    }
    
    public void zeichnen(GraphicsContext gc) {
        //koordinaten
        int ax, ay, bx, by, cx, cy;

        ax = (int) (this.a.getX() + 0.5);
        System.out.println("ax: "+ax);
        ay = (int) (this.a.getY() + 0.5);
        System.out.println("ay: "+ay);
        
        bx = (int) (this.b.getX() + 0.5);
        System.out.println("bx: "+bx);
        by = (int) (this.b.getY() + 0.5);
        System.out.println("by: "+by);

        cx = (int) (this.c.getX() + 0.5);
        System.out.println("cx: "+cx);
        cy = (int) (this.c.getY() + 0.5);
        System.out.println("cy: "+cy);

        gc.setStroke(this.farbe);
        gc.setLineWidth(5);
        gc.strokeLine(ax, ay, bx, by);
        gc.strokeLine(bx, by, cx, cy);
        gc.strokeLine(cx, cy, ax, ay);
        //g.setColor(Color.BLACK);
       //g.drawString("a", ax, ay);
//        g.drawString("b", bx, by);
        //gc.drawString("c", cx, cy);
//        g.drawString(this.getFlaeche()+"", cx, cy);

    }

    @Override
    double getUmfang() {
        throw new UnsupportedOperationException("Not supported yet.");
    }
    

}
